Subject: bug#74488: Why not modernize Emacs

From: Raj Divecha <[email-masked]>
Date: Mon, 25 Nov 2024 17:58:44 +0000 (UTC)

I wish I could contribute but unfortunately I am stuck with my bread & butter job. I am a seasoned systems engineer and mostly work on C/C++/Python, validating features of various ICs that my company manufactures and I know if I want I can work on this non-trivial change but at the end of the day my bread & butter job takes priority over everything else. Just out of curiosity, what will it take to get this done? Is there a document I can review and get a feel for the amount of work? And approximately, how many engineers do you think are needed to work on this and the different expertise required? LISP is kind of dead and the users might need Python to customize their interface, thus, I believe both LISP and Python will have to be supported simultaneously. On Nov 22, 2024, at 11:59 PM, Eli Zaretskii <[email-masked]> wrote: severity 74488 wishlist thanks Date: Fri, 22 Nov 2024 23:27:09 +0000 (UTC) From: Raj Divecha via "Bug reports for GNU Emacs, the Swiss army knife of text editors" <[email-masked]> Hi, I am an occasional Emacs user. I know that Emacs is a very capable editor. In fact, most modern editors provide similar features, just that the learning curve for them is close to nothing. They simply work out of the box. Thus, I am wondering, why not Emacs? How difficult would it be to provide a different interface, a simpler one yet fully capable? For example, while I can use Emacs for simple text editing, I still can't use it as my developer IDE. I want some feature that will help me easily install a project explorer like extension. The project explorer could help create workspaces, project, help me navigate them with ease etc. Think MS's VS Code. On the same lines, I would like a LaTeX window with its own extensions. Emacs already supports all this but the learning curve is so steep that I don't feel like opening it anymore! Thus wondering why can't Emacs come out with a simpler interface (and allow one to switch to an advance interface when needed) and throw the learning curve out the window? -OR- Am I missing something? Thanks, Raj The simple answer to your questions is "because no one has yet proposed code changes to implement those features." Emacs is developed by a loosely-coupled group of volunteers, each one of whom contributes changes in the areas that are of interest to him/her and match their domains of expertise. We acknowledge the need and the advantages of having the advanced IDE-related features work out of the box, but have no way of assigning someone to the job of actually doing that non-trivial job. It is non-trivial because different users of Emacs have different interests and needs (e.g., develop in vastly different programming languages), and setting up the tools we have to fit the needs of a particular user is a complex task. In addition, unlike VS Code, we don't want to promote non-free servers and services, so it is much more difficult for us to provide OOTB configuration for features that rely on external programs and servers. But if and when someone comes with code that does one of these jobs, we embrace that very quickly. Examples include Tree-Sitter based major modes, LSP support via Eglot, etc. Thus, volunteers are welcome to contribute additional features that will make Emacs a better IDE, and ease the learning curve for newcomers. Thank you for your interest in Emacs.